#include "Gra.ch"
#include "Xbp.ch"
#include "XBPDEV.CH"
#include "Font.ch"

#pragma Library( "XppUI2.lib" )

PROCEDURE Main
   LOCAL oPrinter, oDlg, aSize, nAltMode, oFont
   SET DATE TO    GERMAN
   SET CHARSET TO ANSI
   SET alternate to PrinterInfos.txt
   SET alternate on


   cls

   oDlg := XbpPrintDialog():new()
   oDlg:create()
   // Konfiguriertes Drucker Objekt erzeugen
   oPrinter := oDlg:display()
   oDlg:destroy()

   IF oPrinter <> NIL
      ? "Drucker:           "
      ? ":devName           ",oPrinter:devName
      ? ":comment           ",oPrinter:comment
      ? ":devParams         ",oPrinter:devParams,   "  (von Windows nicht untersttzt)"
      ? ":devPort           ",oPrinter:devPort
      ? ":location          ",oPrinter:location
      ? ":spoolFormat       ",oPrinter:spoolFormat, "  (von Windows nicht untersttzt)"
      ? ":spoolJobName      ",oPrinter:spoolJobName,"  (siehe StartDoc() Parameter)"
      ? ":getHDC()          ",oPrinter:getHDC(),    "  (fr API Aufrufe) "
      ? "Drucker Papier Formulare:"
      ? ":forms()           ",ParameterInfo(oPrinter:forms())
      ? "Drucker Papier Fcher:"
      ? ":paperBins()       ",ParameterInfo(oPrinter:paperBins())
      ? "Drucker Papier Gren:"
      ? ":paperSize()       ",ParameterInfo(oPrinter:paperSize())
      ? "Druckerstatus:"
      ? ":printerStatus()   ",PrinterStatus(oPrinter:printerStatus())
      ? "Druckerauflsungen:"
      ? ":resolutions()     ",ParameterInfo(oPrinter:resolutions())
      ?
      ? "Einstellungen:"
      ? ":setCollationMode()",ParameterInfo(oPrinter:setCollationMode())
      ? ":setColorMode()    ",ParameterInfo(oPrinter:setColorMode())
      ? ":setDuplexMode()   ",DuplexModeName(oPrinter:setDuplexMode())
      ? ":setFontMode()     ",PrinterFontMode(oPrinter:setFontMode())
      ? ":setFormSize()     ",ParameterInfo(oPrinter:setFormSize()),  "    ==> :forms() "
      ? ":setNumCopies()    ",ParameterInfo(oPrinter:setNumCopies())
      ? ":setPaperBin()     ",ParameterInfo(oPrinter:setPaperBin()),  "    ==> :paperBins() "
      ? ":setPrintFile()    ",ParameterInfo(oPrinter:setPrintFile())
      ? ":setResolution()   ",ParameterInfo(oPrinter:setResolution()),"    ==> :resolutions() "
      ?
      ? "WICHTIG Drucker Parameter Auswahl:"
      ?
      ? ":setupDialog()      kann alle speziellen Werte fr diesen Drucker setzen"
      ?
      ? "Ende"
      // Aufrumen
      oPrinter:destroy()

   ENDIF
   set alternate to
   inkey(20)

RETURN
*------------------------------------------------------------------------------
function ParameterInfo(xInfo)
return iif(xInfo=NIL,"   ->   wird nicht untersttzt",xInfo)
*------------------------------------------------------------------------------
function DuplexModeName(nMode)
   local cReturn
   do case
      case nMode == NIL
           cReturn := "   ->   wird nicht untersttzt"
      case nMode == XBPPRN_DUPLEXMODE_OFF
           cReturn := "   ->   DUPLEX aus"
      case nMode == XBPPRN_DUPLEXMODE_BOOK
           cReturn := "   ->   DUPLEX BOOK"
      case nMode == XBPPRN_DUPLEXMODE_MEMO
           cReturn := "   ->   DUPLEX MEMO"
      otherwise
           cReturn := "   ->   DUPLEX UNBEKANNT"
   endcase
return cReturn
*------------------------------------------------------------------------------
function PrinterStatus(nStatus)
   local cReturn
   do case
      case nStatus = XBPPRN_STATUS_PAUSED
           cReturn := "angehalten"
      case nStatus = XBPPRN_STATUS_READY
           cReturn := "bereit"
      case nStatus = XBPPRN_STATUS_BUSY
           cReturn := "beschftigt"
      case nStatus = XBPPRN_STATUS_SERVICE
           cReturn := "SERVICE !"
      case nStatus = XBPPRN_STATUS_NOPAPER
           cReturn := "PAPIER !"
      case nStatus = XBPPRN_STATUS_NOT_READY
           cReturn := "nicht bereit"
      case nStatus = XBPPRN_STATUS_NA
           cReturn := "nicht verfgbar"
      case nStatus = XBPPRN_STATUS_ERROR
           cReturn := "FEHLER !"
      case nStatus = XBPPRN_STATUS_OFFLINE
           cReturn := "OFFLINE !"
      otherwise
           cReturn := "UNBEKANNT"
   endcase
return cReturn
*------------------------------------------------------------------------------
function PrinterFontMode(nP)
   local cReturn
   do case
      case nP = XBPPRN_FONTMODE_GRAPHIC
           cReturn := "TT-Fonts als Grafik drucken."
      case nP = XBPPRN_FONTMODE_DOWNLOAD
           cReturn := "Soft-Fonts statt TT-Fonts."
      case nP = XBPPRN_FONTMODE_DOWNLOADOUTL
           cReturn := "Outline Soft-Fonts statt TT-Fonts."
      case nP = XBPPRN_FONTMODE_SUBSTITUTE
           cReturn := "Gertefonts statt TT-Fonts."
      otherwise
           cReturn := "UNBEKANNT"
   endcase
return cReturn
*------------------------------------------------------------------------------

